# AppleIIAsm Technical Manual v0.6.0

---

Written and edited by Nathan Riggs (so far), 2021.

---



















---

### License

Copyright 2020 Nathan Riggs

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

(http://www.apache.org/licenses/LICENSE-2.0)

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and
limitations under the License.

---



















---

## Table of Contents

1. [License](#license)
2. [Preface](1.0%20Preface.md)
3. [Introduction](2.0%20Introduction.md)
4. [Package Overiew](3.0%20Package_Overview.md)
5. [Software Architecture](4.0%20Software_Architecture.md)
6. [Macro/Subroutine Quick References](5.0%20Quick_Reference_TOC.md)
7. - [Quick Reference Introduction](5.0%20Quick_Reference_TOC.md)
   - [Disk 1 -- REQUIRED Macros](6.0%20Quick_Reference_D1_MAC.REQUIRED.md)
   - [Disk 2 -- STDIO Macros](7.0%20Quick_Reference_D2_MAC.STDIO.md)
   - [Disk 3 -- ARRAYS Macros](8.0%20Quick_Reference_D3_MAC.ARRAYS.md)
   - [Disk 4 -- MATH Macros](9.0%20quick_reference_d4_mac.math.md)
   - [Disk 5 -- STRING Macros](10.0%20quick_reference_d5_mac.strings.md)
   - [Disk 6 -- DOS Macros](11.0%20quick_reference_d6_mac.dos.md)
   - [Disk 7 -- CONVERT Macros](12.0%20quick_reference_d7_mac.convert.md)
   - [Disk 8 -- LORES Macros](13.0%20quick_reference_d8_mac.lores.md)
   - [Disk 9 -- HIRES Macros](14.0%20quick_reference_d9_mac.hires.md)
   - [Disk 10 -- SPEAKER Macros](15.0%20quick_reference_d10_mac.speaker.md)
7. Detailed References and Source Code Listings
   - [Disk 1: Required Library and Aliases](30.0%20Detailed_Reference_D1_REQUIRED.md)
   - [Disk 2: STDIO Macros and Subroutines](31.0%20Detailed_Reference_D2_STDIO.md)
   - [Disk 3: Array Macros and Subroutines](32.0%20Detailed_Reference_D3_Arrays.md)
   - [Disk 4: Basic Math Macros and Subroutines](33.0%20Detailed_Reference_D4_MATH.md)
   - [Disk 5: String Manipulation Macros and Subroutines](34.0%20Detailed_Reference_D5_STRINGS.md)
   - [Disk 6: Apple DOS Macros and Subroutines](35.0%20Detailed_Reference_D6_DOS.md)
   - [Disk 7: Data Type Conversion Macros and Subroutines](36.0%20Detailed_Reference_D7_CONVERT.md)
   - [Disk 8: Low Resolution Macros and Subroutines](37.0%20Detailed_Reference_D8_LORES.md)
   - [Disk 9: High Resolution Macros and Subroutines](38.0%20Detailed_Reference_D9_HIRES.md)
   - [Disk 10: Internal Macros and Subroutines](39.0%20Detailed_Reference_D10_SPEAKER.md)
8. Appendices
   - Supplemental Texts
   - Further Reference
   - Optimizations
     - Typical Assembly Optimizations
     - Architecture Clobbering Optimizations
