*
*``````````````````````````````*
* HEAD.STDIO.ASM               *
*                              *
* THIS FILE CONTAINS HOOKS AND *
* VARIABLES USED BY THE STDIO  *
* LIBRARY. SOME ARE INCLUDED   *
* BUT ARE COMMENTED OUT, DUE   *
* TO NOT BEING USED BY THE     *
* LIBRARY; THEY ARE THERE FOR  *
* THE USER TO UNCOMMENT, IF    *
* NEEDED.                      *
*                              *
* THIS FILE ALSO INCLUDES VERY *
* COMMONLY USED ROUTINES IN    *
* THE LIBRARY SUBROUTINES.     *
*                              *
* AUTHOR:    NATHAN RIGGS      *
* CONTACT:   NATHAN.RIGGS@     *
*            OUTLOOK.COM       *
*                              *
* DATE:      11-MAR-2021       *
* ASSEMBLER: MERLIN 8 PRO      *
* OS:        DOS 3.3           *
*,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,*
*
* OUTPUT HOOKS
*
COUT1    EQU   $FDF0      ; FASTER SCREEN OUTPUT
COUT     EQU   $FDED      ; MONITOR STD OUTPUT
HOME     EQU   $FC58      ; CLEAR SCREEN, HOME CURSOR
VTAB     EQU   $FC22      ; MONITOR CURSOR POS ROUTINE
CURSH    EQU   $24        ; HPOS OF COUT CURSOR
CURSV    EQU   $25        ; VPOS OF COUT CURSOR
KEYBUFF  EQU   $0200      ; KEYBUFFER START
GSTROBE  EQU   $C040      ; GAME CONNECTOR STROBE
GBCALC   EQU   $F847      ; SCREEN CALCULATION
GBPSH    EQU   $26
*
* INPUT HOOKS
*
KYBD     EQU   $C000      ; LDA SINGLE KEYPRESS
STROBE   EQU   $C010      ; CLEAR KYBD BUFFER
GETLN    EQU   $FD6F      ; MONITOR GET LINE OF KB INPUT
GETKEY   EQU   $FD0C      ; MONITOR GET SINGLE KEY INPUT
*
* PADDLE HOOKS
*
PREAD    EQU   $FB1E      ; READ STATE OF PADDLE
PB0      EQU   $C061      ; PADDLE BUTTON 0
PB1      EQU   $C062
PB2      EQU   $C063
PB3      EQU   $C060
*
** UNUSED BY LIBRARY
*
*WNDLEFT EQU $20 ; SCROLL WINDOW LEFT
*WNDWIDTH EQU $21 ; SCROLL WINDOW WIDTH
*WNDTOP EQU $22 ; SCROLL WINDOW TOP
*WNDBOT EQU $23 ; SCROLL WINDOW BOTTOM
*TEXTP1 EQU $0400 ; START OF TEXT PAGE 1
*TEXTP2 EQU $0800 ; START OF TEXT PAGE 2
*PAGE1 EQU $C054 ; SOFT SWITCH USE PAGE 1
*PAGE2 EQU $C055 ; SOFT SWITCH USE PAGE 2
*S80COL EQU $C01F ; READ ONLY; CHECK IF 80C
*TXTSET EQU $C051 ; TEXT ON SOFT SWITCH
*SETWND EQU $FB4B ; SET NORMAL WINDOW MODE
*CURADV EQU $FBF4 ; ADVANCE CURSOR RIGHT
*CURBS EQU $FC10 ; CURSOR LEFT
*CURUP EQU $FC1A ; CURSOR UP
*CR EQU $FC62 ; CARRIAGE RETURN TO SCREEN
*LF EQU $FC66 ; LINE FEED ONLY TO SCREEN
*CLEOL EQU $FC9C ; CLEAR TEXT TO END OF LINE
*OPAPP EQU $C061
*CLAPP EQU $C062
