*
*``````````````````````````````*
* HEAD.MATH.ASM                *
*                              *
*                              *
* AUTHOR:    NATHAN RIGGS      *
* CONTACT:   NATHAN.RIGGS@     *
*            OUTLOOK.COM       *
*                              *
* DATE:      22-MAR-2021       *
* ASSEMBLER: MERLIN 8 PRO      *
* OS:        DOS 3.3           *
*,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,*
*
GETNUM   EQU   $FFA7      ; ASCII TO HEX IN 3E & 3F
RNDL     EQU   $4E        ; RANDOM NUMBER LOW
RNDH     EQU   $4F        ; RANDOM NUMBER HIGH
*
FAC      EQU   $9D        ; FLOATING POINT ACCUM
FSUB     EQU   $E7A7      ; FLOATING POINT SUBTRACT
FADD     EQU   $E7BE
FMULT    EQU   $E97F      ; FP MULTIPLY
FDIV     EQU   $EA66      ; FP DIVIDE
FMULTT   EQU   $E982
FDIVT    EQU   $EA69
FADDT    EQU   $E7C1
FSUBT    EQU   $E7AA
*
MOVFM    EQU   $EAF9      ; MOVE FAC > MEM
MOVMF    EQU   $EB2B      ; MOVE MEM > FAC
NORM     EQU   $E82E
CONUPK   EQU   $E9E3
*
FLOG     EQU   $E941      ; LOGARITHM
FSQR     EQU   $EE8D      ; SQUARE ROOT
FCOS     EQU   $EFEA      ; FP COSINE
FSIN     EQU   $EFF1      ; SINE
FTAN     EQU   $F03A      ; TANGENT
FATN     EQU   $F09E      ; ATANGENT
*
** THE FOLLOWING IS A SERIES OF "MAGIC NUMBERS"
** TO USE AS SEEDS FOR PSEUDO-RANDOM NUMBER GENERATION.
** THESE CAN BE FOUND ON CODEBASE64, BUT ARE KNOWN
** WELL ENOUGH TO BE CONSIDERED COMMON KNOWLEDGE.
*
         JMP   ]MATH_GO
]MAGEOR  HEX   002D
]MAGNUM  HEX   002D0039003F005300BD00D7012F013D
         HEX   014F015D019701A101AD01BF01C70215
         HEX   02190225022F025D026D0285029102A1
         HEX   02E5031D034B036903710387038D039F
         HEX   03A303DD03F904290457046704830489
         HEX   049104BF04C1053305470569058705C3
         HEX   05DD05EB0641064B0653068B06C3076B
         HEX   076D0779078307F1080D086108BF08D5
]MATH_GO
*
